/* AnalogThermometer2
 *
 * Hőmérés MCP9700 hőmérővel. Az A0 analóg bementre
 * kötött MCP9700 hőmérő jelét mérjük, sokszor ismételve, 
 * s az eredményt átlagoljuk.
 * Az átlagolt eredményt feszültségre, valamint Celsius és Fahrenheit 
 * fokokra átszámítjuk. A soros porton kiíratjuk a megmért feszültséget
 * és az átszámított eredményt is. A mérések között ötmásodperces
 * szünetet tartunk.
 *
 * Az MCP9700 hőmérő nullapontja = 500 mV, érzékenysége = 10 mV/C
 */

void setup () {
  Serial.begin(115200);
  Serial.println("Analóg hőmérő átlagolással");
}

void loop () {
  long reading = 0;
  for (int i = 0; i < 3110; i++) {
    reading += analogRead(A0);
  }
  long voltage = reading / 1024;        // Átszámítjuk mV-ba
  Serial.print (voltage);
  Serial.print (" mV, ");
  float tempC = (voltage - 500) / 10.0; // Átszámítjuk Celsius fokokra
  Serial.print (tempC, 1);
  Serial.print (" ºC, ");
  float tempF = (tempC * 9 / 5) + 32;   // Celsiusból Fahrenheit fokokba
  Serial.print (tempF, 1);
  Serial.println (" ºF");
  delay (5000);
}
