/* ESP8288_dimmer
 *  
 * Az SW1 és SW2 nyomógombok segítségével LED2 fényerejét 
 * fokozatosan változtatjuk, miközben folyamatosan 
 * villogtatjuk LED1-et.
 * 
 * A LED-ek most felhúzásra világítanak (az anódokat vezéreljük).
 * 
 * Tested with ESP8266 Arduino Core ver 2.7.4 and Arduino IDE 1.8.13
 */



#include <Ticker.h>
Ticker dimmer;

#define LED1 D0       // GPIO16
#define LED2 D1       // GPIO5
#define SW1  D2       // GPIO4
#define SW2  D3       // GPIO0

uint16_t dim_value = 0;

void buttoncheck() {
  if (!digitalRead(SW1) && (dim_value < 255)) dim_value++ ;
  if (!digitalRead(SW2) && (dim_value > 0)) dim_value-- ;
}

void setup() {
  pinMode(LED1, OUTPUT);
  analogWriteRange(65535);
  analogWrite(LED2, dim_value);
  pinMode(SW1, INPUT_PULLUP);
  pinMode(SW2, INPUT_PULLUP);
  dimmer.attach(0.05, buttoncheck);
}

void loop() {
  analogWrite(LED2, dim_value * dim_value);
  digitalWrite(LED1, HIGH);  // Turn the other LED on
  delay(250);                // Wait for 250 ms
  analogWrite(LED2, dim_value * dim_value);
  digitalWrite(LED1, LOW);   // Turn the other LED off
  delay(250);                // Wait for 250 ms
}
