/* ESP8266_interrupt
 * 
 * Az SW1 és SW2 nyomógomb megszakításokkal 
 * be és ki kapcsolgatjuk LED2-t, miközben 
 * folyamatosan villogtatjuk LED1-et
 * A LED-ek lehúzásra világítanak (katódvezérlés).
 * 
 * Tested with ESP8266 Arduino Core ver 2.7.4
 * and Arduino IDE 1.8.13
 */


#define LED1 D0       // GPIO16
#define LED2 D1       // GPIO5
#define SW1  D2       // GPIO4
#define SW2  D3       // GPIO0

ICACHE_RAM_ATTR void sw1_handler(void) {
  digitalWrite(LED2, LOW);   // LED2 on  
}

ICACHE_RAM_ATTR void sw2_handler(void) {
  digitalWrite(LED2, HIGH);  // LED2 off  
}

void setup() {
  pinMode(LED1, OUTPUT);
  digitalWrite(LED1, HIGH);
  pinMode(LED2, OUTPUT);
  digitalWrite(LED2, HIGH);
  pinMode(SW1, INPUT_PULLUP);
  pinMode(SW2, INPUT_PULLUP);
  attachInterrupt(SW1,sw1_handler,FALLING);
  attachInterrupt(SW2,sw2_handler,FALLING);
}

void loop() {
  digitalWrite(LED1, LOW);   // Turn the other LED on
  delay(100);                // Wait for a 100 ms
  digitalWrite(LED2, HIGH);  // Turn the other LED off
  delay(1000);               // Wait for 1000 ms
}
